<?php

namespace backend\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use backend\models\AdminMenu;

/**
 * AdminMenuSearch represents the model behind the search form about `backend\models\AdminMenu`.
 */
class AdminMenuSearch extends AdminMenu
{


    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['admin_menu_id', 'admin_menu_pid', 'status', 'hide_min', 'sort'], 'integer'],
            [['name', 'path', 'param','parentt'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = AdminMenu::find();

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'pagination' => [
                'pageSize' => 5
            ],
            'sort' => [
                'attributes' => [
                    'admin_menu_id',
                    'name',
                    'path',
                    'param',
                    'status',
                    'hide_min',
                    'parentt' => [
                        'asc' => ['name' => SORT_ASC],
                        'desc' => ['name' => SORT_DESC],
                        'default' => SORT_DESC
                    ]
                ]
            ]
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'admin_menu_id' => $this->admin_menu_id,
            'admin_menu_pid' => $this->admin_menu_pid,
            'status' => $this->status,
            'hide_min' => $this->hide_min,
            'sort' => $this->sort
        ]);


        $query->andFilterWhere(['like', 'name', $this->name])
            ->andFilterWhere(['like', 'path', $this->path])
            ->andFilterWhere(['like', 'param', $this->param])
            ->andFilterWhere(['in', 'admin_menu_pid', $this->find()->select(['admin_menu_id'])->andFilterWhere(['like', 'name', $this->parentt])->column()]);

        return $dataProvider;
    }
}
